



#if !defined (__CYLINDER_H)
#define __CYLINDER_H

#include "geo.h"


/* *************************************************************
************************************************************* */
class cylinder : public geo {

   protected:
   
      // pc
      void transform(eye *parm);

      // geo
      void pg(eye *parm, light *lmain, light *spot, zbuffer *zbuff);
      void lt(spotlight *spot);
      void geo2poly(texpolygon **ptob, shaderlisttype *slist);
      float calc_area();
      
      // cylinder
      float master_length, length, master_hlength, hlength, master_radius, radius;

   public:
   
      // superclass
      int  query_whatami() { return OBJECT_CYLINDER; }
	  int  query_whatwasi(int type);
      int  parse(FILE *infile, char *token);
      void preprocess(void *data);
      
      // frameclass
      int  dump_frame(FILE *outfile);
      
      // pc
      void bound_sphere();
      void datacopy();
      
      // cylinder
      cylinder() {
         master_hlength = 0.5;
         master_radius = 1;
         master_length = 2;
      }

      virtual ~cylinder() {}
};


/* *************************************************************
************************************************************* */
class cylinder_loader : public loader {

   public:
      superclass *make_object() { return new cylinder; }
      cylinder_loader() { object_name = TOKEN_GEOCYLINDER_STR; }
      virtual ~cylinder_loader() {}
};

#endif

